package cc.smtweb.system.bpm.test;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.spring.BpmApplication;
import cc.smtweb.system.bpm.web.design.form.ModelForm;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

/**
 * Created by Akmm at 2022/4/26 9:46
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = BpmApplication.class)
public class ModelFormTest {
    @Test
    public void testLoad() {
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("dataset", "modelProject");
        SwMap filter = new SwMap();
        filter.put("prj_name", "测试");
        params.put("filter", filter);
        DynPageService service = new DynPageService();
        R r = service.load(params, null);
        System.out.println(r.readSuccess());
    }

    @Test
    public void testSave() {
        //{pageId,dataset:"", data:{form:{},list: {total:0,rows:[]}}, filter:{}}
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("dataset", "modelProject");
        SwMap data = new SwMap();
        SwMap form = new SwMap();
        form.put("prj_id", "12345");
        form.put("prj_name", "test12345");
        form.put("prj_desc", "this is test12345");
        data.put("form", form);
        params.put("data", data);
        SwMap filter = new SwMap();
        filter.put("prj_name", "测试");
        params.put("filter", filter);
        DynPageService service = new DynPageService();
        R r = service.saveOne(params, null);
        System.out.println(r.readSuccess());
    }

    @Test
    public void testDel() {
        //{pageId,dataset:"", data:{form:{},list: {total:0,rows:[]}}, filter:{}}
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("id", 12345);

        DynPageService service = new DynPageService();
        R r = service.del(params, null);
        System.out.println(r.readSuccess());
    }

    @Test
    public void testBuildModelByTmpl() {
        ModelForm form = new ModelForm();
        form.setTitle("测试呀");
        form.setDataset("[{\"id\":\"ds_1813718bf0c\",\"name\":\"master\",\"label\":\"机构列表\",\"type\":\"list\",\"masterTable\":\"718391823709507584\",\"masterTable_text\":\"机构表\",\"idField\":\"pt_id\",\"lazy\":false,\"canEdit\":false,\"fields\":[{\"id\":\"id_1813718bf0e\",\"table\":\"718391823709507584\",\"field\":\"pt_id\",\"name\":\"pt_id\",\"fieldType\":1,\"notNull\":1,\"link\":\"0\"},{\"id\":\"id_1813718bf0f\",\"table\":\"718391823709507584\",\"field\":\"pt_parent_id\",\"name\":\"pt_parent_id\",\"fieldType\":4,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf10\",\"table\":\"718391823709507584\",\"field\":\"pt_level_code\",\"name\":\"pt_level_code\",\"fieldType\":5,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf11\",\"table\":\"718391823709507584\",\"field\":\"pt_area_id\",\"name\":\"pt_area_id\",\"fieldType\":0,\"notNull\":0,\"link\":\"718410950209703936\"},{\"id\":\"id_1813718bf12\",\"table\":\"718391823709507584\",\"field\":\"pt_code\",\"name\":\"pt_code\",\"fieldType\":2,\"notNull\":1,\"link\":\"0\"},{\"id\":\"id_1813718bf13\",\"table\":\"718391823709507584\",\"field\":\"pt_name\",\"name\":\"pt_name\",\"fieldType\":3,\"notNull\":1,\"link\":\"0\"},{\"id\":\"id_1813718bf14\",\"table\":\"718391823709507584\",\"field\":\"pt_type\",\"name\":\"pt_type\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf15\",\"table\":\"718391823709507584\",\"field\":\"pt_statu\",\"name\":\"pt_statu\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf16\",\"table\":\"718391823709507584\",\"field\":\"pt_linker\",\"name\":\"pt_linker\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf17\",\"table\":\"718391823709507584\",\"field\":\"pt_tel\",\"name\":\"pt_tel\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf18\",\"table\":\"718391823709507584\",\"field\":\"pt_addr\",\"name\":\"pt_addr\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf19\",\"table\":\"718391823709507584\",\"field\":\"pt_lon\",\"name\":\"pt_lon\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf1a\",\"table\":\"718391823709507584\",\"field\":\"pt_lat\",\"name\":\"pt_lat\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"},{\"id\":\"id_1813718bf1b\",\"table\":\"718391823709507584\",\"field\":\"pt_remark\",\"name\":\"pt_remark\",\"fieldType\":0,\"notNull\":0,\"link\":\"0\"}],\"filters\":[{\"id\":\"id_1813718bf21\",\"table\":\"718391823709507584\",\"field\":\"pt_name\",\"name\":\"pt_code\",\"fieldType\":3,\"notNull\":1,\"link\":\"0\",\"type\":\"input\",\"sqlName\":\"pt_name\",\"required\":false}],\"data\":[],\"dynCond\":{\"opt\":\"or\",\"children\":[{\"param\":\"pt_code\",\"opt\":\"like\"},{\"param\":\"pt_code\",\"opt\":\"like\"}]},\"sortFields\":[{\"field\":\"pt_code\",\"type\":\"asc\"}]}]");
        form.setTmpl("{\n" +
                "    \"param\": {\n" +
                "      \"p1\": \"pp1\"\n" +
                "    },\n" +
                "    \"layout\": {\n" +
                "      \"c1\": [\n" +
                "        {\n" +
                "          \"name\": \"group2\",\n" +
                "          \"label\": \"分组2\",\n" +
                "          \"type\": \"list\",\n" +
                "          \"dataset\": \"ds_1813718bf0c\",\n" +
                "          \"fields\": [\n" +
                "            {\n" +
                "              \"field\": \"pt_parent_id\",\n" +
                "              \"dataset\": \"ds_1813718bf0c\"\n" +
                "            }\n" +
                "          ],\n" +
                "          \"cfilters\": [\n" +
                "            {\n" +
                "              \"field\": \"pt_code\",\n" +
                "              \"dataset\": \"ds_1813718bf0c\"\n" +
                "            }\n" +
                "          ]\n" +
                "        }\n" +
                "      ]\n" +
                "    }\n" +
                "  }");
        ModelFormHelper.buildSaveModelByTmpl(form, "model_simple");
        System.out.println(form.getContent());
    }
}
